const std    = @import("std");
const dvui   = @import("dvui");
const hncore = @import("hncore");

const win = @import("./win/root.zig");

const Self = @This();

alloc: std.mem.Allocator,
today: win.today.Mock,

pub fn init(alloc: std.mem.Allocator) !Self {
    return Self {
        .alloc = alloc,
        .today = try win.today.Mock.init(alloc),
    };
}
pub fn deinit(self: *Self) void {
    self.today.deinit();
}

pub fn gui(self: *Self) !void {
    // ---- menu
    {
        var root = try dvui.menu(@src(), .horizontal, .{ .background = true, .expand = .horizontal });
        defer root.deinit();

        if (try dvui.menuItemLabel(@src(), "File", .{ .submenu = true }, .{})) |r| {
            var float = try dvui.floatingMenu(
                @src(), .{.from = dvui.Rect.fromPoint(dvui.Point{ .x = r.x, .y = r.y + r.h })}, .{});
            defer float.deinit();

            if (try dvui.menuItemLabel(@src(), "Open", .{}, .{})) |_| {
            }
        }
    }

    // ---- project tabs
    {
        var tbox = try dvui.box(@src(), .vertical, .{
            .expand = .both,
            .background = true,
            .color_fill = .{ .name = .fill_window },
        });
        defer tbox.deinit();
    }

    // ---- windows
    try win.today.gui(&self.today);
}
